unit ParseFile_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    StatusBar1: TStatusBar;
    Button1: TButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure ParseFile(FileName:TFileName);
    procedure WriteSentence(mot1,mot2:string);
    procedure FormResize(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    function  RegleApostrophe(mot:string):string;
    function  RegleSaint(mot:string):string;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
if OpenDialog1.Execute then begin
  ParseFile(OpenDialog1.FileName);
  StatusBar1.Panels[0].Text:=OpenDialog1.FileName;
  end;
end;

procedure TForm1.ParseFile(FileName:TFileName);
  var Fh:TFileStream;
  ville,cp:string;
  b:char;
begin
ListBox1.Clear;

Fh:=TFileStream.Create(Filename,fmOpenRead);

ville:='';
cp:='';

while fh.Read(b,1)=1 do begin
  if b in ['a'..'z','A'..'Z'] then ville:=concat(ville,b)
  else if b in ['0'..'9'] then
      if length(cp)<5 then cp:=concat(cp,b)
      else begin
      if length(ville)>0 then
        WriteSentence(ville,cp);
      ville:=''; cp:=b;
      end
  else if (length(ville)>0) and (length(cp)>0) then // ce n'est ni une lettre ni un chiffre
    if b=' ' then
      ville:=concat(ville,b);
  end;

Fh.free;
end;

procedure TForm1.WriteSentence(mot1,mot2:string);
begin
ListBox1.items.add(mot2+' '+RegleSaint(RegleApostrophe(mot1)));
StatusBar1.Panels[1].Text:=IntToStr(ListBox1.Items.count);
end;


procedure TForm1.FormResize(Sender: TObject);
var i:integer;
begin
for i:=0 to StatusBar1.Panels.count-1 do
  StatusBar1.Panels[i].Width:=StatusBar1.width div StatusBar1.Panels.count;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Listbox1.Items.SaveToFile('ParsedFile.txt');
end;


function TForm1.RegleApostrophe(mot:string):string;
var i:integer;
  s,p:integer;
{ 0 initial
  1 on a trouv un blanc
  2 on a trouv un L en tat 1
  3 on a trouv un blanc en tat 2 : on a gard la position du blanc
  4 on trouv une voyelle en tat 3 : mettre un guillemet
}
begin
s:=1; //prsence d'un blanc initial
p:=0;
result:=mot;
for i:=1 to length(mot) do begin
  case s of
  0 : if mot[i]=' ' then s:=1 else s:=0;
  1 : if mot[i] in ['L','l','D','d'] then s:=2 else s:=0;
  2 : if mot[i] = ' ' then begin s:=3; p:=i; end else s:=0;
  3 : if mot[i] in ['a','e','i','o','u','h','y','A','E','I','O','U','Y','H'] then s:=4 else s:=0;
  end;
  if s=4 then begin
    result[p]:='''';
    result:=RegleApostrophe(Result); // rcursif
    break;
    end;
  end;
end;




function TForm1.RegleSaint(mot:string):string;
var i:integer;
  s,p:integer;
{
0:etat initial
1:on a trouv un blanc
2:on a trouv un S
3:on a trouv un T
4:on a trouv une consonne autre que H ou Y : il s'agit d'un ST concatn on ajoute un blanc
}
begin
s:=1; //prsence d'un blanc initial
p:=0;
result:=mot;
for i:=1 to length(mot) do begin
  case s of
  0 : if mot[i]=' ' then s:=1 else s:=0;
  1 : if mot[i] in ['S','s'] then s:=2 else s:=0;
  2 : if mot[i] in ['T','t'] then s:=3 else s:=0;
  3 : if not (mot[i] in ['a','e','i','o','u','h','y','A','E','I','O','U','Y','H',' ']) then s:=4 else s:=0;
  end;
  if s=4 then begin
    insert(' ',result,i);
    break;
    end;
  end;

end;

end.
